<script setup>
// imports
import { computed } from 'vue';
// props
const props = defineProps({
  title: { type: String, default: '' },
  postition: { type: String, default: 'right' }
})
// data
const tooltipClass = computed(() => {
  switch(props.postition) {
  case 'left':
    return 'left-tooltip'
    break;
  case 'top':
    return 'top-tooltip'
    break;
    case 'bottom':
    return 'bottom-tooltip'
    break;
  default:
    return 'right-tooltip'
}
})
</script>

<template>
  <div class="tooltip-wrapper group">
    <div :class="tooltipClass" class="tooltip">
      {{ props.title }}
    </div>
    <slot />
  </div>
</template>

<style scoped lang="scss">
.tooltip-wrapper {
  @apply relative w-fit flex items-center;
  .tooltip {
    @apply absolute shadow-md bg-background-primary-light dark:bg-background-primary-dark rounded-xs px-2 py-1 opacity-0 invisible transition-all min-w-max;
  }

  .left-tooltip {
    right: 60px;
  }

  .right-tooltip {
    left: 60px;
  }

  .top-tooltip {
    bottom: 60px;
    left: 50%;
    transform: translateX(-50%);
  }

  .bottom-tooltip {
    top: 60px;
    left: 50%;
    transform: translateX(-50%);
  }

  &:hover {
    .tooltip {
      @apply visible opacity-100;
    }
    .left-tooltip {
      right: 30px;
    }

    .right-tooltip {
      left: 30px;
    }

    .top-tooltip {
      bottom: 30px;
    }

    .bottom-tooltip {
      top: 30px;
    }
  }
}
</style>
